<?php
/**
 * Plugin Name:     Whatsapp floating icon
 * Plugin URI:      https://www.netdesign.media/whatsapp-fi
 * Description:     add floating icon with a link to whatsapp
 * Author:          Tomer Ofer
 * Author URI:      https://www.netdesign.media
 * Text Domain:     wa-fi
 * Domain Path:     /languages
 * Version:         0.3.0
 *
 * @package         Whatsapp_Floating_Icon
 */

defined( 'ABSPATH' ) or exit();

add_action( 'admin_init', 'register_wa_fi_settings' );
function register_wa_fi_settings() { // whitelist options
	register_setting( 'wa-fi-option-group', 'wa_fi_offset_x' );
	register_setting( 'wa-fi-option-group', 'wa_fi_offset_x_mobile' );
	register_setting( 'wa-fi-option-group', 'wa_fi_offset_y' );
	register_setting( 'wa-fi-option-group', 'wa_fi_offset_y_mobile' );
	register_setting( 'wa-fi-option-group', 'wa_fi_title' );
	register_setting( 'wa-fi-option-group', 'wa_fi_link' );
	register_setting( 'wa-fi-option-group', 'wa_fi_phone' );
	register_setting( 'wa-fi-option-group', 'wa_fi_message' );
	register_setting( 'wa-fi-option-group', 'wa_fi_type' );
	register_setting( 'wa-fi-option-group', 'wa_fi_link_structure' );
	register_setting( 'wa-fi-option-group', 'wa_fi_position' );
	register_setting( 'wa-fi-option-group', 'wa_fi_tooltip_text' );
	register_setting( 'wa-fi-option-group', 'wa_fi_tooltip_enabled' );
	register_setting( 'wa-fi-option-group', 'wa_fi_mobile_breakpoint' );
}

add_action('wp_head', 'wa_fi_print_floating_icon_styles');
function wa_fi_print_floating_icon_styles(){
	$position = esc_attr( get_option('wa_fi_position') );
	$offset_x = esc_attr( get_option('wa_fi_offset_x') );
	$offset_x_mobile = esc_attr( get_option('wa_fi_offset_x_mobile') );
	$offset_y = esc_attr( get_option('wa_fi_offset_y') );
	$offset_y_mobile = esc_attr( get_option('wa_fi_offset_y_mobile') );
	$wa_fi_mobile_breakpoint = esc_attr( get_option('wa_fi_mobile_breakpoint') );
	if(empty($wa_fi_mobile_breakpoint)){
		$wa_fi_mobile_breakpoint = "576";
    }
	switch($position){
        case "bottom_left":
	        $positionCss = "bottom: 20px;left: 20px;";
	        $positionCssMobile = "bottom: 15px;left: 15px;";
	        if($offset_x && is_numeric($offset_x)){
	            $positionCss .= "margin-left: {$offset_x}px;";
	        }
	        if(is_numeric($offset_x_mobile)){
		        $positionCssMobile .= "margin-left: {$offset_x_mobile}px;";
	        }
	        if($offset_y && is_numeric($offset_y)){
		        $positionCss .= "margin-bottom: {$offset_y}px;";
	        }
	        if(is_numeric($offset_y_mobile)){
		        $positionCssMobile .= "margin-bottom: {$offset_y_mobile}px;";
	        }
	        $positionTooltipText = "bottom: 100%;left: 100%;";
	        $positionLogo = "float:left;";
	        $positionTitle = "margin-left: 10px;";
	        break;
		case "top_left":
			$positionCss = "top: 20px;left: 20px;";
			$positionCssMobile = "top: 15px;left: 15px;";
			if($offset_x && is_numeric($offset_x)){
				$positionCss .= "margin-left: {$offset_x}px;";
			}
			if(is_numeric($offset_x_mobile)){
				$positionCssMobile .= "margin-left: {$offset_x_mobile}px;";
			}
			if($offset_y && is_numeric($offset_y)){
				$positionCss .= "margin-top: {$offset_y}px;";
			}
			if(is_numeric($offset_y_mobile)){
				$positionCssMobile .= "margin-top: {$offset_y_mobile}px;";
			}
			$positionTooltipText = "top: 100%;left: 100%;";
			$positionLogo = "float:left;";
			$positionTitle = "margin-left: 10px;";
			break;
		case "top_right":
			$positionCss = "top: 20px;right: 20px;";
			$positionCssMobile = "top: 15px;right: 15px;";
			if($offset_x && is_numeric($offset_x)){
				$positionCss .= "margin-right: {$offset_x}px;";
			}
			if(is_numeric($offset_x_mobile)){
				$positionCssMobile .= "margin-right: {$offset_x_mobile}px;";
			}
			if($offset_y && is_numeric($offset_y)){
				$positionCss .= "margin-top: {$offset_y}px;";
			}
			if(is_numeric($offset_y_mobile)){
				$positionCssMobile .= "margin-top: {$offset_y_mobile}px;";
			}
			$positionTooltipText = "top: 100%;right: 100%;";
			$positionLogo = "float:right;";
			$positionTitle = "margin-right: 10px;";
			break;
		case "bottom_right":
		default:
			$positionCss = "bottom: 20px;right: 20px;";
			$positionCssMobile = "bottom: 15px;right: 15px;";
			if($offset_x && is_numeric($offset_x)){
				$positionCss .= "margin-right: {$offset_x}px;";
			}
			if(is_numeric($offset_x_mobile)){
				$positionCssMobile .= "margin-right: {$offset_x_mobile}px;";
			}
		    if($offset_y && is_numeric($offset_y)){
                $positionCss .= "margin-bottom: {$offset_y}px;";
            }
		    if(is_numeric($offset_y_mobile)){
                $positionCssMobile .= "margin-bottom: {$offset_y_mobile}px;";
            }
			$positionTooltipText = "bottom: 100%;right: 100%;";
			$positionLogo = "float:right;";
			$positionTitle = "margin-right: 10px;";
			break;
	}
    echo '<style>.wa-fi-wrapper{display: flex;align-items: center;z-index: 10000;position: fixed;'.$positionCss.'}.wa-fi-wrapper a{'.$positionLogo.'display: block;width: 65px;height: 65px;box-shadow: 1px 1px 5px 2px #9f9f9f;background-color: #fff;border-radius: 50%;}.wa-fi-wrapper svg{max-width: 100%;max-height: 100%;}.wa-fi-wrapper .wa-fi-tooltip {position: absolute;top: -5px;right: 0;}.wa-fi-wrapper .wa-fi-tooltip .qm-icon{display: block;width: 12px;height: 12px;font-size: 10px;background-color: #ff0000;color: #fff;line-height: 1;text-align: center;border-radius: 15px;padding: 2px 0;cursor: pointer;user-select: none;}.wa-fi-wrapper .wa-fi-tooltip-text {position: absolute;font-size: 12px;'.$positionTooltipText.'width: 180px;background-color: #fff;line-height: 1;padding: 5px;}.wa-fi-wrapper .wa-fi-title {'.$positionTitle.'font-size: 14px;line-height: 1;max-width: 120px;display: inline-block;background-color: #fff;text-align: center;box-shadow: 1px 1px 5px 2px #9f9f9f;border-radius: 4px;padding: 2px 0;}</style>';
	echo '<style>@media(max-width: '.$wa_fi_mobile_breakpoint.'px){.wa-fi-wrapper {'.$positionCssMobile.'}}</style>';
}

add_action('wp_footer', 'wa_fi_print_floating_icon');

function wa_fi_print_floating_icon(){
	$position = esc_attr( get_option('wa_fi_position') );
	$link = esc_attr( get_option('wa_fi_link') );
	$linkStructure = esc_attr( get_option('wa_fi_link_structure') );
	$phone = esc_attr( get_option('wa_fi_phone') );
	$message = esc_attr( get_option('wa_fi_message') );
	$type = esc_attr( get_option('wa_fi_type') );
	$title = trim(esc_attr( get_option('wa_fi_title') ));
	$tooltipText = trim(esc_attr( get_option('wa_fi_tooltip_text') ));
	$tooltipEnabled = esc_attr( get_option('wa_fi_tooltip_enabled') );
	$href = "";
	if($type === 'group'){
		$href = $link;
	}else{
	    if($linkStructure === 'app'){
		    $href = "whatsapp://send?phone={$phone}?text={$message}";
	    }else{
		    $href = "https://api.whatsapp.com/send?phone={$phone}?text={$message}";
	    }
	}
	$icon = '<svg height="512px" viewBox="-1 0 512 512" width="512px" xmlns="http://www.w3.org/2000/svg"><path d="m10.894531 512c-2.875 0-5.671875-1.136719-7.746093-3.234375-2.734376-2.765625-3.789063-6.78125-2.761719-10.535156l33.285156-121.546875c-20.722656-37.472656-31.648437-79.863282-31.632813-122.894532.058594-139.941406 113.941407-253.789062 253.871094-253.789062 67.871094.0273438 131.644532 26.464844 179.578125 74.433594 47.925781 47.972656 74.308594 111.742187 74.289063 179.558594-.0625 139.945312-113.945313 253.800781-253.867188 253.800781 0 0-.105468 0-.109375 0-40.871093-.015625-81.390625-9.976563-117.46875-28.84375l-124.675781 32.695312c-.914062.238281-1.84375.355469-2.761719.355469zm0 0" fill="#e5e5e5"/><path d="m10.894531 501.105469 34.46875-125.871094c-21.261719-36.839844-32.445312-78.628906-32.429687-121.441406.054687-133.933594 109.046875-242.898438 242.976562-242.898438 64.992188.027344 125.996094 25.324219 171.871094 71.238281 45.871094 45.914063 71.125 106.945313 71.101562 171.855469-.058593 133.929688-109.066406 242.910157-242.972656 242.910157-.007812 0 .003906 0 0 0h-.105468c-40.664063-.015626-80.617188-10.214844-116.105469-29.570313zm134.769531-77.75 7.378907 4.371093c31 18.398438 66.542969 28.128907 102.789062 28.148438h.078125c111.304688 0 201.898438-90.578125 201.945313-201.902344.019531-53.949218-20.964844-104.679687-59.09375-142.839844-38.132813-38.160156-88.832031-59.1875-142.777344-59.210937-111.394531 0-201.984375 90.566406-202.027344 201.886719-.015625 38.148437 10.65625 75.296875 30.875 107.445312l4.804688 7.640625-20.40625 74.5zm0 0" fill="#fff"/><path d="m19.34375 492.625 33.277344-121.519531c-20.53125-35.5625-31.324219-75.910157-31.3125-117.234375.050781-129.296875 105.273437-234.488282 234.558594-234.488282 62.75.027344 121.644531 24.449219 165.921874 68.773438 44.289063 44.324219 68.664063 103.242188 68.640626 165.898438-.054688 129.300781-105.28125 234.503906-234.550782 234.503906-.011718 0 .003906 0 0 0h-.105468c-39.253907-.015625-77.828126-9.867188-112.085938-28.539063zm0 0" fill="#64b161"/><g fill="#fff"><path d="m10.894531 501.105469 34.46875-125.871094c-21.261719-36.839844-32.445312-78.628906-32.429687-121.441406.054687-133.933594 109.046875-242.898438 242.976562-242.898438 64.992188.027344 125.996094 25.324219 171.871094 71.238281 45.871094 45.914063 71.125 106.945313 71.101562 171.855469-.058593 133.929688-109.066406 242.910157-242.972656 242.910157-.007812 0 .003906 0 0 0h-.105468c-40.664063-.015626-80.617188-10.214844-116.105469-29.570313zm134.769531-77.75 7.378907 4.371093c31 18.398438 66.542969 28.128907 102.789062 28.148438h.078125c111.304688 0 201.898438-90.578125 201.945313-201.902344.019531-53.949218-20.964844-104.679687-59.09375-142.839844-38.132813-38.160156-88.832031-59.1875-142.777344-59.210937-111.394531 0-201.984375 90.566406-202.027344 201.886719-.015625 38.148437 10.65625 75.296875 30.875 107.445312l4.804688 7.640625-20.40625 74.5zm0 0"/><path d="m195.183594 152.246094c-4.546875-10.109375-9.335938-10.3125-13.664063-10.488282-3.539062-.152343-7.589843-.144531-11.632812-.144531-4.046875 0-10.625 1.523438-16.1875 7.597657-5.566407 6.074218-21.253907 20.761718-21.253907 50.632812 0 29.875 21.757813 58.738281 24.792969 62.792969 3.035157 4.050781 42 67.308593 103.707031 91.644531 51.285157 20.226562 61.71875 16.203125 72.851563 15.191406 11.132813-1.011718 35.917969-14.6875 40.976563-28.863281 5.0625-14.175781 5.0625-26.324219 3.542968-28.867187-1.519531-2.527344-5.566406-4.046876-11.636718-7.082032-6.070313-3.035156-35.917969-17.726562-41.484376-19.75-5.566406-2.027344-9.613281-3.035156-13.660156 3.042969-4.050781 6.070313-15.675781 19.742187-19.21875 23.789063-3.542968 4.058593-7.085937 4.566406-13.15625 1.527343-6.070312-3.042969-25.625-9.449219-48.820312-30.132812-18.046875-16.089844-30.234375-35.964844-33.777344-42.042969-3.539062-6.070312-.058594-9.070312 2.667969-12.386719 4.910156-5.972656 13.148437-16.710937 15.171875-20.757812 2.023437-4.054688 1.011718-7.597657-.503906-10.636719-1.519532-3.035156-13.320313-33.058594-18.714844-45.066406zm0 0" fill-rule="evenodd"/></g></svg>';
	echo "<div class='wa-fi-wrapper'>";
	if($tooltipEnabled && $tooltipText){
	    echo "<div class='wa-fi-tooltip'><span class='qm-icon'>?</span><span style='display: none;' class='wa-fi-tooltip-text'>{$tooltipText}</span></div>";
    }
	if($title && ($position === "top_left" || $position === "bottom_left")) {
		echo "<div class='wa-fi-title'>{$title}</div>";
	}
	echo "<a target='_blank' href='{$href}'>{$icon}";
	echo "</a>";
	if($title && ($position === "top_right" || $position === "bottom_right")) {
		echo "<div class='wa-fi-title'>{$title}</div>";
	}
	echo "</div>";
}

add_action( 'admin_menu', 'wa_fi_plugin_menu' );
function wa_fi_plugin_menu() {
	add_options_page( 'Whatsapp floating icon', 'Whatsapp Icon', 'manage_options', 'whatsapp-floating-icon', 'wa_fi_plugin_options' );
}
function wa_fi_plugin_options() {
	if ( ! current_user_can( 'manage_options' ) ) {
		wp_die( __( 'You do not have sufficient permissions to access this page.' ) );
	}

	$title = esc_attr( get_option('wa_fi_title') );
	$currentLink = esc_attr( get_option('wa_fi_link') );
	$currentPosition = esc_attr( get_option('wa_fi_position') );
	$offset_x = esc_attr( get_option('wa_fi_offset_x') );
	$offset_x_mobile = esc_attr( get_option('wa_fi_offset_x_mobile') );
	$offset_y = esc_attr( get_option('wa_fi_offset_y') );
	$offset_y_mobile = esc_attr( get_option('wa_fi_offset_y_mobile') );
	$currentPhone = esc_attr( get_option('wa_fi_phone') );
	$currentMessage = esc_attr( get_option('wa_fi_message') );
	$currentType = esc_attr( get_option('wa_fi_type') );
	$currentLinkStructure = esc_attr( get_option('wa_fi_link_structure') );
	$tooltipText = esc_attr( get_option('wa_fi_tooltip_text') );
	$tooltipEnabled = esc_attr( get_option('wa_fi_tooltip_enabled') );
	$mobileBreakpoint = esc_attr( get_option('wa_fi_mobile_breakpoint') );
	$types = [
		'message' => 'Message to a phone number',
		'group' => 'Group link'
	];
	$linkStructures = [
        'api' => 'API (api.whatsapp.com)',
        'app' => 'APP (whatsapp://)'
    ];
	$positions = [
	        'bottom_right' => 'Bottom right',
	        'bottom_left' => 'Bottom left',
	        'top_left' => 'Top left',
	        'top_right' => 'Top right',
    ];
	$mobileBreakpoints = [
	    "576",
        "767",
        "991"
    ];
	?>
	<div class="wrap">
		<h1>Whatsapp floating icon</h1>
		<form method="post" action="options.php">
			<?php settings_fields( 'wa-fi-option-group' ); ?>
			<?php do_settings_sections( 'wa-fi-option-group' ); ?>
			<table class="form-table">
                <tr>
                    <th scope="row"><label for="wa_fi_title">Title</label></th>
                    <td>
                        <input style="width: 300px;" type="text" name="wa_fi_title" id="wa_fi_title" aria-label="Title" value="<?= $title ?>">
                    </td>
                </tr>
				<tr>
					<th scope="row"><label for="wa_fi_type">Type</label></th>
					<td>
                        <select name="wa_fi_type" id="wa_fi_type">
                            <option value="">Choose type</option>
                            <?php foreach($types as $typeValue => $typeLabel){ ?>
                            <option value="<?= $typeValue ?>" <?php echo ($typeValue == $currentType ? 'selected="selected"':'') ?>><?= $typeLabel ?></option>
                            <?php } ?>
                        </select>
					</td>
				</tr>
	            <?php if($currentType === 'message'){ ?>
                <tr>
                    <th scope="row"><label for="wa_fi_link_structure">Link structure</label></th>
                    <td>
                        <select name="wa_fi_link_structure" id="wa_fi_link_structure">
							<?php foreach($linkStructures as $lsValue => $lsLabel){ ?>
                                <option value="<?= $lsValue ?>" <?php echo ($lsValue == $currentLinkStructure ? 'selected="selected"':'') ?>><?= $lsLabel ?></option>
							<?php } ?>
                        </select>
                    </td>
                </tr>
                <?php } ?>
				<?php if($currentType === 'message'){ ?>
                    <tr>
                        <th scope="row"><label for="wa_fi_message">Message</label></th>
                        <td>
                            <textarea style="width: 300px;resize: vertical;height: 100px;" name="wa_fi_message" id="wa_fi_message" aria-label="Message"><?= $currentMessage ?></textarea>
                        </td>
                    </tr>
                    <tr>
                        <th scope="row"><label for="wa_fi_phone">Phone</label></th>
                        <td>
                            <input style="width: 300px;" type="tel" name="wa_fi_phone" id="wa_fi_phone" aria-label="Phone" value="<?= $currentPhone ?>">
                        </td>
                    </tr>
				<?php }elseif($currentType === 'group'){ ?>
                    <tr>
                        <th scope="row"><label for="wa_fi_link">Link</label></th>
                        <td>
                            <input style="width: 300px;" type="url" name="wa_fi_link" id="wa_fi_link" aria-label="Link" value="<?= $currentLink ?>">
                        </td>
                    </tr>
				<?php }else{ ?>
                    <tr>
                        <th scope="row"></th>
                        <td>
                            <p>choose a type to configure your floating icon</p>
                        </td>
                    </tr>
				<?php } ?>
                <tr>
                    <th scope="row"><label>Tooltip enabled</label></th>
                    <td>
                        <label><input type="radio" name="wa_fi_tooltip_enabled" <?= $tooltipEnabled === "yes" ? 'checked':''  ?> value="yes"> Yes</label>
                        <label><input type="radio" name="wa_fi_tooltip_enabled" <?= $tooltipEnabled === "no" ? 'checked':''  ?> value="no"> No</label>
                    </td>
                </tr>
                <tr>
                    <th scope="row"><label for="wa_fi_tooltip_text">Tooltip text</label></th>
                    <td>
                        <textarea style="width: 300px;resize: vertical;height: 100px;" name="wa_fi_tooltip_text" id="wa_fi_tooltip_text" aria-label="Tooltip text"><?= $tooltipText ?></textarea>
                    </td>
                </tr>
                <tr>
                    <th scope="row"><label for="wa_fi_mobile_breakpoint">Mobile breakpoint</label></th>
                    <td>
                        <select name="wa_fi_mobile_breakpoint" id="wa_fi_mobile_breakpoint">
                            <?php foreach ($mobileBreakpoints as $breakpoint){ ?>
                                <option value="<?= $breakpoint ?>" <?php echo ($mobileBreakpoint == $breakpoint ? 'selected="selected"':'') ?>>max-width: <?= $breakpoint ?>px</option>
                            <?php } ?>
                        </select>
                    </td>
                </tr>
                <tr>
                    <th scope="row"><label for="wa_fi_position">Position</label></th>
                    <td>
                        <select name="wa_fi_position" id="wa_fi_position">
							<?php foreach($positions as $positionValue => $positionLabel){ ?>
                                <option value="<?= $positionValue ?>" <?php echo ($positionValue == $currentPosition ? 'selected="selected"':'') ?>><?= $positionLabel ?></option>
							<?php } ?>
                        </select>
                    </td>
                </tr>
                <tr>
                    <th scope="row"><label>Offset X</label></th>
                    <td>
                        <div style="margin-bottom: 10px;">
                            <label style="display: block;margin-bottom: 5px;" for="wa_fi_offset_x">Desktop</label>
                            <input type="number" min="0" step="1" name="wa_fi_offset_x" id="wa_fi_offset_x" value="<?= $offset_x ?: 0 ?>">
                        </div>
                        <label style="display: block;margin-bottom: 5px;" for="wa_fi_offset_x_mobile">Mobile</label>
                        <input type="number" min="0" step="1" name="wa_fi_offset_x_mobile" id="wa_fi_offset_x_mobile" value="<?= $offset_x_mobile ?: 0 ?>">
                    </td>
                </tr>
                <tr>
                    <th scope="row"><label>Offset Y</label></th>
                    <td>
                        <div style="margin-bottom: 10px;">
                            <label style="display: block;margin-bottom: 5px;" for="wa_fi_offset_y">Desktop</label>
                            <input type="number" min="0" step="1" name="wa_fi_offset_y" id="wa_fi_offset_y" value="<?= $offset_y ?: 0 ?>">
                        </div>
                        <label style="display: block;margin-bottom: 5px;" for="wa_fi_offset_y_mobile">Mobile</label>
                        <input type="number" min="0" step="1" name="wa_fi_offset_y_mobile" id="wa_fi_offset_y_mobile" value="<?= $offset_y_mobile ?: 0 ?>">
                    </td>
                </tr>
			</table>
			<?php submit_button(); ?>
		</form>
	</div>
	<?php
}

add_action('wp_enqueue_scripts', 'wa_fi_register_scripts');
function wa_fi_register_scripts(){
	$scriptPath = plugins_url('whatsapp-fi/script.js');
	wp_enqueue_script('wa-fi-script', $scriptPath, array('jquery'), null, true);
}
